#include <fstream.h>
#include <math.h>
#include "krak.h"
#include "interval.h"

void test_templates(void){
  rootFrame.Clear();
  frstring text("[1,2.5][3.5,4.5]");

  interval i,j;
  rootFrame << "text=\"" << text << "\"\n";
  text >> i >> j;
  rootFrame << "After reading i and j from text:\n";
  rootFrame << "i = " << i << " j= " << j << "\n";
  rootFrame << "text=\"" << text << "\"\n";
  rootFrame << "After inserting \"i=value of i\" to text:\n";
  text << "i=" << i;
  rootFrame << "text=\"" << text << "\"\n";
  rootFrame << "And indeed i=" << i << "\n";
  waitBt();
}


void testExp(interval z){
  rootFrame << "z=" << z << "\n";
  interval expintv=exp(z);
  double dexp=exp(z.right_b());
  rootFrame << "diff in exp: our intervalexp - standardexp " << (expintv - dexp) << "\n";
}

void testExp(){
  rootFrame.Clear();
  rootFrame << "Testing exp(interval)\n\n";

  testExp(1.01);
  testExp(0.99);
  testExp(0.5);
/* ponizej objawia sie blad, ale tylko przy wylaczonej obsludze niedozwolonej operacji przez
   procesor INTEL (IM = 0 w bitach maskowania bledow numerycznych
*/
  testExp(12.0);
  waitBt();
}


void test_sin(interval z){
  rootFrame << "z=" << z << "\n";
  interval sinintv=sin(z);
  double dsin=sin(z.right_b());
  rootFrame << "diff in sin: our interval sin  - standard sin " << (sinintv - dsin) << "\n";
}

void test_sin()
{
  rootFrame.Clear();
  rootFrame << "Testing sin(interval)\n\n";
  test_sin(pi);
  test_sin(6.0);
  test_sin(1.0);
  waitBt();
}

void show_rounding_test(void){
   frstring result;
   rootFrame << At(0,0) << "Testing rounding:\n\n";

   round_nearest();
   result=(rounding_test() == 0 ? "OK" : "BAD");
   rootFrame << "Rounding nearest: " << result << "\n";

   round_down();
   result=(rounding_test() == 1 ? "OK" : "BAD");
   rootFrame << "Rounding down:    " << result << "\n";

   round_up();
   result=(rounding_test() == 2 ? "OK" : "BAD");
   rootFrame << "Rounding up:      " << result << "\n";

   round_cut();
   result=(rounding_test() == 3 ? "OK" : "BAD");
   rootFrame << "Rounding cut:     " << result << "\n";
   waitBt();
}


int main(int /*argc*/, char* /*argv*/[])
begin


  init_fpunit();

  #ifdef DEBUGGING
    cerr << "DEBUGGING" << endl;
  #endif

  #ifdef KRAK
    cerr << "KRAK" << endl;
  #endif
  openGW( 760,580,WHITE,BLACK);

  /* test verifying if rounding mechanism works properly */
  show_rounding_test();

#ifdef UP_ROUNDING
  round_up();
#endif

  /* test for the exp(interval) function - it has problems!!! */
  testExp();

  /* some other tests */
  test_templates();


  /* simple test of sin function */
  test_sin();

  closeGW();
  return 0;
end;
